class SDPPayInitBean {
   /*
   0 = {map entry} "version" -> "10"
   1 = {map entry} "mer_no" -> "6888802041659"
   2 = {map entry} "mer_key" -> "123"
   3 = {map entry} "mer_order_no" -> "1234"
   4 = {map entry} "create_time" -> "20180813142345"
   5 = {map entry} "expire_time" -> "20180813142415"
   6 = {map entry} "order_amt" -> "0.01"
   7 = {map entry} "notify_url" -> "http://sandcash/notify"
   8 = {map entry} "return_url" -> ""
   9 = {map entry} "create_ip" -> "192_168_0_1"
   10 = {map entry} "goods_name" -> "测试商品"
   11 = {map entry} "store_id" -> "000000"
   12 = {map entry} "product_code" -> "02010005,02020004"
   13 = {map entry} "clear_cycle" -> "0"
   14 = {map entry} "pay_extra" -> ""
   15 = {map entry} "accsplit_flag" -> "NO"
   16 = {map entry} "activity_no" -> ""
   17 = {map entry} "benefit_amount" -> ""
   18 = {map entry} "jump_scheme" -> "sandcash://scpay"
   19 = {map entry} "sign_type" -> "MD5"
   20 = {map entry} "sign" -> "14689162e048aa29109e742efd6591c7"
   21 = {map entry} "gh_static_url" -> ""
   22 = {map entry} "limit_pay" -> "" */
   /// 移动应用id 和包名是对应的
   final String? wxAppId;
   ///门店号 没有填默认值 000000 必填
   final String? storeId;
   ///用户所在客户端的真实ip其中的“.”替换为“_” 。如 192_168_0_1。 如出现多个ip，只传最外层 必填
   final String? createIp;
   ///杉德渠道
   final String? merNo;

   ///结果查询接口 URL
   final String? queryURL;



   SDPPayInitBean({
      this.wxAppId = "wx24932e45899137eb",
      this.storeId  = "100001",
      this.createIp = "172_12_12_12",
      this.merNo    = "16938552",
      this.queryURL = "http://192.168.2.35:8888/payQuery",
   });
}